dofile("Base.rte/Constants.lua")
require("AI/NativeHumanAI") --dofile("Base.rte/AI/NativeHumanAI.lua")

function Create(self)
	self.enableselect = true

	self.mapwrapx = SceneMan.SceneWrapsX
	self.checkWidth = 20
	self.checkHeight = 10

	self.activeCamo = false
	self.camoSwitchTimer = Timer()
	self.camoSwitchTime = 250

	self.redeyeOffset = Vector(7, -14)
	self.redeye = nil
	self.redeye = CreateMOPixel("Blue Glow")
	self.redeye.Pos = self.Pos + self.redeyeOffset
	MovableMan:AddParticle(self.redeye)

	self.CloakTimer = Timer()

	self.AI = NativeHumanAI:Create(self)
end

function Update(self)
	if self:IsPlayerControlled() == true then
		if self.enableselect == true then
			self.selected = CreateAEmitter("ACTA Black Select")
			self.selected.Pos = self.Pos
			self.selected.PinStrength = 1000
			MovableMan:AddParticle(self.selected)
			self.enableselect = false
		end
	else
		self.enableselect = true
	end

	--IF THE UNIT IS NOT DEAD...
	if not (self:IsDead()) then
		if MovableMan:ValidMO(self.redeye) then
			self.redeye.Pos = self.Pos + self.redeyeOffset:RadRotate(self.RotAngle)
			self.redeye:NotResting()
			self.redeye.Age = 0
			self.redeye.ToSettle = false
		end

		--IF ACTIVE CAMO IS ON, DO THESE THINGS
		if self.activeCamo == true then
			--CHECK FOR INCOMING PROJECTILES
			for particle in MovableMan.Particles do
				self.parvector = SceneMan:ShortestDistance(self.Pos, particle.Pos, self.mapwrapx)
				local pardist = self.parvector.Magnitude

				local shieldradius = 65
				local mindetectspeed = 20
				if pardist < shieldradius then
					if particle.HitsMOs == true and particle.Team ~= self.Team then
						if particle.Vel.Magnitude > mindetectspeed then
							self.CloakTimer:Reset()
							self.change = true
						end
					end
				end
			end

			if self.Vel.Magnitude > 15 then
				self.CloakTimer:Reset()
				self.change = true
			end

			--SEE IF UNIT IS FIRING
			if
				self:GetController():IsState(Controller.WEAPON_FIRE)
				or self:GetController():IsState(Controller.WEAPON_RELOAD)
			then
				self.CloakTimer:Reset()
				self.change = true
			end
			--CREATE RED EYE EFFECT
			local redeyeOffset = Vector(7, -14)
			if self.HFlipped then
				redeyeOffset = Vector(-7, -14)
			end
			local redeye = CreateMOPixel("Blue Glow")
			redeye.Pos = self.Pos + redeyeOffset:RadRotate(self.RotAngle)
			MovableMan:AddParticle(redeye)
		end

		--SYSTEM OF CHECKS TO INFORM INVISIBLITY SYSTEM WHETHER OR NOT IT SHOULD ACTIVATE
		if self.CloakTimer:IsPastSimMS(0) and not self.CloakTimer:IsPastSimMS(135) then
			self.change = true
			self.HUDVisible = true
		end
		if self.CloakTimer:IsPastSimMS(135) and not self.CloakTimer:IsPastSimMS(975) and self.activeCamo == true then
			self.change = true
		end
		if self.CloakTimer:IsPastSimMS(975) and not self.CloakTimer:IsPastSimMS(1175) then
			self.change = true
		end
		if self.CloakTimer:IsPastSimMS(1175) and self.activeCamo == false then
			self.change = true
			self.HUDVisible = false
		end

		--INVISIBILITY SYSTEM: HANDLE ACTUAL INVISIBILITY CHANGE
		if self.change == true then
			for i = 0, MovableMan:GetMOIDCount() do
				if MovableMan:GetRootMOID(i) == self.ID then
					local object = MovableMan:GetMOFromID(i)
					if not (object:IsDevice()) or (object:IsDevice() and (object.PresetName == "Tacitus Sword")) then
						if self.activeCamo == true then
							object.Scale = 1
						else
							object.Scale = 0

							--CREATE RED EYE EFFECT
							local redeyeOffset = Vector(7, -14)
							if self.HFlipped then
								redeyeOffset = Vector(-7, -14)
							end
							local redeye = CreateMOPixel("Blue Glow 2")
							redeye.Pos = self.Pos + redeyeOffset:RadRotate(self.RotAngle)
							MovableMan:AddParticle(redeye)
						end
					end
				end
			end

			if self.activeCamo == true then
				self.activeCamo = false
			else
				self.activeCamo = true
			end

			self.change = false
		end
	else
		--...IF THE UNIT IS DEAD, PERFORM END LIFE FUNCTIONS
		for i = 0, MovableMan:GetMOIDCount() do
			if MovableMan:GetRootMOID(i) == self.ID then
				local object = MovableMan:GetMOFromID(i)
				if not (object:IsDevice()) or (object:IsDevice() and (object.PresetName == "Tacitus Sword")) then
					object.Scale = 1
					self.HUDVisible = true
				end
			end
		end
		self.RotAngle = self.RotAngle * 0.98
	end
end

function UpdateAI(self)
	self.AI:Update(self)
end
