require("AI/HumanBehaviors")

function Create(self)
	self.AI = NativeHumanAI:Create(self)
	self.HealTimer = Timer()
	self.ActivateTimer = Timer()
	self.ActivationTime = 2400
end

function Update(self)
	if self.Health < 110 then
		if self.HealTimer:IsPastSimMS(700) then
			self.Health = math.min(self.Health + 2, 100)
			self.HealTimer:Reset()
		end
		if self.ActivateTimer:IsPastSimMS(self.ActivationTime) then
			for actor in MovableMan.Actors do
				self.dist = SceneMan:ShortestDistance(self.Pos, actor.Pos, true)
				for i = 1, 24, 3 do
					self.LoS = SceneMan:CastMORay(
						self.Pos - Vector(0, i),
						Vector(self.dist.X, self.dist.Y),
						self.ID,
						self.IgnoresWhichTeam,
						128,
						false,
						0
					)
					if self.LoS ~= 255 then
						break
					end
				end
				if
					self.dist.Magnitude < 360
					and actor.Team ~= self.Team
					and actor.ClassName ~= "ADoor"
					and not actor:HasObjectInGroup("Brains")
					and self.LoS ~= 255
				then
					actor:AddImpulseForce(Vector(self.dist.X, self.dist.Y - 25):SetMagnitude(0), Vector(0, 0))
					actor:DropAllInventory()
					actor:GetController():SetState(Controller.WEAPON_DROP, true)
					actor:GetController():SetState(Controller.BODY_CROUCH, true)
					self.Fx = CreateMOSRotating("Stun Effect")
					self.Fx.Pos = actor.Pos
					self.Fx.Vel = actor.Vel
					self.Fx.Mass = 1.000001
					self.Fx.Sharpness = 4
					MovableMan:AddParticle(self.Fx)
				end
			end
			self.ActivateTimer:Reset()
		end
	end
end

function UpdateAI(self)
	self.AI:Update(self)
end
